require('file_helper')
require('fogbugz_api')

fogcache_recently_changed = {}

local function debug(x) end

local function extractListHtml(Html)
   return Html:gsub('.*(%<ul class="wikiArticleList">)(.*)%<ul id="wikiViewPaging">.*', '%1%2')
end

local function fixHtmlLinks(Html)
   local Html = Html
   Html = Html:gsub('href="default.asp%?W([0-9]+)"', 'href="%1.html"')
   Html = Html:gsub('Last edited by [^\n]+ on', 'Last edited on')
   Html = Html:gsub('Created by [^\n]+ on', 'Created on')
   Html = Html:gsub('<span class="starContainer">[^\n]+\n[^\n]+\n[^\n]+</span>', '')
   return Html
end

local Token

function fogcache_recently_changed.generateRecentlyChangedPages(Config)
   
   Token = fogbugz_api.logonIfNeeded(Config.BASE_URL, Config.EMAIL, Config.PASSWORD, Token)
   
   local Html = fogbugz_api.recentlyChangedPage(Config.BASE_URL, Token, Config.WIKI_ID)
   
   local ListHtml = extractListHtml(Html)
   debug(ListHtml)

   local PageCount = Html:gsub('.*Page ([0-9]+) of ([0-9]+).*', '%2')
   
   PageCount = tonumber(PageCount)
   debug(PageCount)
   
   local StartPage =  (Config.START_PAGE or '1')..(Config.SUFFIX or '')..'.html'
   
   for PageNumber = 1, PageCount do
      
      if iguana.isTest() and PageNumber ~= 1 and PageNumber ~=2 and PageNumber ~= PageCount-1 and PageNumber ~=PageCount then
         -- skip the bulk of pages while in editor - these take too long -
         -- FIXME until #18433 Script is taking too long dialog gets attitude-adjusted
      else
         local PageHtml = fogbugz_api.recentlyChangedPage(Config.BASE_URL, Token, Config.WIKI_ID, PageNumber)
         local PageListHtml = extractListHtml(PageHtml)
         local PageFixedListHtml = fixHtmlLinks(PageListHtml)
         
         local LabelArrowPrev = Config.LABEL_ARROW_PREV or '&larrow; Prev'
         local LabelArrowNext = Config.LABEL_ARROW_NEXT or 'Next &rarrow;'
         local LabelArrowSep = Config.LABEL_ARROW_SEP or ' | '
         
         local PageNavHtml = ''
         local PageNavHtmlArrow = ''
         
         if PageNumber > 1 then
            PageNavHtml = PageNavHtml .. '<a href="RecentlyChanged.'..(PageNumber-1)..'.html">Prev</a>'
            PageNavHtmlArrow = PageNavHtmlArrow .. '<a href="RecentlyChanged.'..(PageNumber-1)..'.html">'..LabelArrowPrev..'</a>'
         else
            PageNavHtml = PageNavHtml .. 'Prev'
            PageNavHtmlArrow = PageNavHtmlArrow .. LabelArrowPrev
         end
         
         PageNavHtml = PageNavHtml .. ' | '
         PageNavHtmlArrow = PageNavHtmlArrow .. LabelArrowSep
         
         if PageNumber < PageCount then
            PageNavHtml = PageNavHtml .. '<a href="RecentlyChanged.'..(PageNumber+1)..'.html">Next</a>'
            PageNavHtmlArrow = PageNavHtmlArrow .. '<a href="RecentlyChanged.'..(PageNumber+1)..'.html">'..LabelArrowNext..'</a>'
         else
            PageNavHtml = PageNavHtml .. 'Next'
            PageNavHtmlArrow = PageNavHtmlArrow .. LabelArrowNext
         end
         
         local PageData = {
            Title='<title>Recently Changed</title>',
            ArticlePath = '""',
            CookieCrumbs = 'Recently Changed',
            StaticTreeview = '',
            TreeHash = '0A6B399EF510051632649ADAD4C899E2',
            Suffix = Config.SUFFIX or '',
            StartPage = Config.START_PAGE or '1',
            EditLink = '',
            Id='1',
            NavHtml = PageNavHtml,
            NavHtmlArrow=PageNavHtmlArrow,
            Content=PageFixedListHtml,
         }

         local PageHtml = Config.generatePage(Config, PageData)
         file_helper.writeFile( Config.destFileName('RecentlyChanged.'..PageNumber..'.html'), PageHtml)

      end -- if not skipping page
   end
end
