require('split_helper')
require('str_helper')

http_helper = {}

function http_helper.cookieNameValue(CookieHeaderValue)
   local PairList = split_helper.split(CookieHeaderValue, ';')
   if not PairList or #PairList < 1 then
      return nil, nil
   end
   local FirstPairSrc = str_helper.stripWhiteSpace(PairList[1], true, true)
   local FirstPairPartList = split_helper.split(FirstPairSrc, '=', 1)
   if #FirstPairPartList ~= 2 then
      return nil, nil
   end
   return FirstPairPartList[1], FirstPairPartList[2]
end

function http_helper.cookieValueByName(MultipleHeaders, CookieName)
   local HeaderName, HeaderData
   local ValueIndex, CookieHeaderValue

   for HeaderName, HeaderData in pairs(MultipleHeaders) do
      if HeaderName:lower() == 'set-cookie' then
         for ValueIndex, CookieHeaderValue in ipairs(HeaderData.Values) do
            local ThisCookieName, ThisCookieValue = http_helper.cookieNameValue(CookieHeaderValue)
            if ThisCookieName == CookieName then
               return ThisCookieValue
            end
         end
      end
   end
   return nil
end
