
str_helper = {}

function str_helper.strip(String, CharList, StripLeading, StripTrailing)
   local PosStart = 1
   local PosEnd = String:len()

   if StripLeading then
      while PosStart <= PosEnd and CharList:find(String:sub(PosStart,PosStart)) do
         PosStart = PosStart + 1
      end
   end
   
   if StripTrailing then
      while PosEnd >= PosStart and CharList:find(String:sub(PosEnd, PosEnd)) do
         PosEnd = PosEnd - 1
      end
   end
   return String:sub(PosStart,PosEnd)
end

local strip = str_helper.strip

function str_helper.unittest()
   assert( strip('<a>', '<>', false, false) == '<a>' )
   assert( strip('<a>', '<>', false, true) == '<a' )
   assert( strip('<a>', '<>', true, false) == 'a>' )
   assert( strip('<a>', '<>', true, true) == 'a' )
   assert( strip('a', '<>', true, true) == 'a')
   assert( strip('', '<>', true, true) == '')
   assert( strip('<>', '<>', true, true) == '')
   assert( strip('<a<b>c>', '<>', true, true) == 'a<b>c')
end

function str_helper.stripWhiteSpace(String, StripLeading, StripTrailing)
   return strip(String, ' \t\r\n', StripLeading, StripTrailing)
end
